//----------------------------------------------------------------------
//EASTRISING TECHNOLOGY CO,.LTD.//
// Module    : ER-OLEDM015-3 
// Lanuage   : C Code
// Create    : JAVEN
// Date      : 2025-03-20
// Drive IC  : SSD1327
// INTERFACE : 4 LINE SPI
// MCU 		   : STM32F103C8T6
//----------------------------------------------------------------------

//Hardware connection
// GND    VSS
// VCC    3.3v
// SCK    PA5
// SDA    PA7
// RES    PB0
// DC     PB1
// CS     PA4 

#include "oled.h"
#include "oledfont.h"

void Delay(unsigned int Data)
{
unsigned int temp;
	for(; Data>0; Data--)
	{
		for(temp=0; temp<0xffF; temp++);
	}
}

//code unsigned char gImage_1[64][128];

void Write_Register(unsigned char Data)
{
	unsigned char i;
	
	OLED_CS_Clr();
	OLED_RS_Clr();
	for (i=0; i<8; i++)
	{
		OLED_SCLK_Clr();                
		if (Data&0x80)
		{//Delay(1);
			OLED_SDIN_Set();
		}
		else
		{//Delay(1);
			OLED_SDIN_Clr();
		}
		Data = Data << 1;
		OLED_SCLK_Set();
	}
	OLED_RS_Set();
	OLED_CS_Set();	
}

void Write_Parameter(unsigned char Data)
{
	unsigned char i;
	
	OLED_CS_Clr();
	OLED_RS_Set();
	for (i=0; i<8; i++)
	{
		OLED_SCLK_Clr();                
		if (Data&0x80)
		{//Delay(1);
			OLED_SDIN_Set();
			
		}
		else
		{//Delay(1);
			OLED_SDIN_Clr();
		}
		Data = Data << 1;
		OLED_SCLK_Set();
	}
	OLED_RS_Set();
	OLED_CS_Set();	
}

//******************************************************************************
//    ˵OLEDʾеʼַֹ
//    ݣa  еʼַ
//              b  еַֹ
//    ֵ  
//******************************************************************************
void Column_Address(unsigned char a, unsigned char b)
{
	Write_Register(0x15);			        // Set Column Address
	Write_Parameter(0x1c+a);				//   Default => 0x00
	Write_Parameter(0x1c+b);				//   Default => 0x77
}

//******************************************************************************
//    ˵OLEDʾеʼַֹ
//    ݣa  еʼַ
//              b  еַֹ
//    ֵ  
//******************************************************************************
void Row_Address(unsigned char a, unsigned char b)
{
	Write_Register(0x75);			// Set Row Address
	Write_Parameter(a);				//   Default => 0x00
	Write_Parameter(b);				//   Default => 0x3F
}

//******************************************************************************
//    ˵OLEDʾ
//    ݣ
//    ֵ  
//******************************************************************************
void ClearLED (unsigned char color)
{
	unsigned char j,i;
	//Column Address
	Set_Colume_Address(0,63);
	// Row Address
	Set_Row_Address(0,127);
	for (j=0;j<128;j++)        /* 64 row */
	{
		for (i=0;i<64;i++)    /* 64*2=128 column  a nibble of command is a dot*/
		{//delay_ms(1);
			 Write_Parameter(color);
		}
	}
}
void Rainbow ()
{
	unsigned char j,i;
	//Column Address
	Set_Colume_Address(0,0x3f);
	// Row Address
	Set_Row_Address(0,0x7f);
	for (j=0;j<128;j++)        /* 64 row */
	{
		for (i=0;i<64;i++)    /* 64*2=128 column  a nibble of command is a dot*/
		{//delay_ms(1);
			 Write_Parameter((j/8)|((j/8)<<4));
		}
	}
}

void Set_Colume_Address(unsigned char Addr1,unsigned char Addr2)
{
	Write_Register(0x15); 
    Write_Register(Addr1); 	//еַʼ
    Write_Register(Addr2);  	//еַ
}

//=======деַ==============
void Set_Row_Address(unsigned char Addr1,unsigned char Addr2)
{
	Write_Register(0x75); 
    Write_Register(Addr1); 	//еַʼ
    Write_Register(Addr2);  	//еַ
}
//============ʾһ8*16ַ==============================

void OLED_ShowChar(u8 x,u8 y,u8 chr)
{unsigned char c=0,i=0;	
/*8x16ϰ벿ּ8x8*/
	u8 j;
	u8 Data1,Data2,DATA1=0;
			c=chr-' ';//õƫƺֵ
	Set_Colume_Address(x,x+3);	
	
	Set_Row_Address(y,y+7);
	//Write_Register(0x5c);
			for(j=0;j<4;j++)
		{
			Data1=F8X16[c*16+2*j];//һĸֽ
			Data2=F8X16[c*16+2*j+1];
				for(i=0;i<8;i++)
			{
				if(Data1&(0x01<<i))	
				{
					DATA1=0xF0;
				}
				else DATA1=0x00;
				if(Data2&(0x01<<i))
				{
					DATA1|=0x0F;
				}	
				Write_Parameter (DATA1);
				DATA1=0;
			}
		}
		
	
	/*****************8x16°벿ּ8x8****************************************/
	Set_Colume_Address(x,x+3);		
	Set_Row_Address(y+8,y+15);
			for(j=4;j<8;j++)
		{
			Data1=F8X16[c*16+2*j];//һĸֽ
			Data2=F8X16[c*16+2*j+1];
				for(i=0;i<8;i++)
			{
				if(Data1&(0x01<<i))	
				{
					DATA1=0xF0;
				}
				else DATA1=0x00;
				if(Data2&(0x01<<i))
				{
					DATA1|=0x0F;
				}	
				Write_Parameter (DATA1);
				DATA1=0;
			}
		}
}	

//ʾһַŴ
void OLED_ShowString(u8 x,u8 y,u8 *chr)
{
	unsigned char j=0;
	while (chr[j]!='\0')
	{		OLED_ShowChar(x,y,chr[j]);
			x+=4;
	
			j++;
	}
}

//m^n
u32 oled_pow(u8 m,u8 n)
{
	u32 result=1;	 
	while(n--)result*=m;    
	return result;
}				  
//ʾ2
//x,y :	 
//len :ֵλ
//size:С
//mode:ģʽ	0,ģʽ;1,ģʽ
//num:ֵ(0~4294967295);	 		  
void OLED_ShowNum(u8 x,u8 y,u32 num,u8 len,u8 size)
{         	
	u8 t,temp;
	u8 enshow=0;						   
	for(t=0;t<len;t++)
	{
		temp=(num/oled_pow(10,len-t-1))%10;
		if(enshow==0&&t<(len-1))
		{
			if(temp==0)
			{
				OLED_ShowChar(x+(size/8)*t,y,' ');
				continue;
			}else enshow=1; 
		 	 
		}
	 	OLED_ShowChar(x+8*t,y,temp+'0'); 
	}
}


void OLED_ShowCHinese(u8 x,u8 y,u8 no)
{unsigned char i=0;	
/*8x16ϰ벿ּ8x8*/
	u8 j;
	u8 Data1,Data2,DATA1=0;
	
	Set_Colume_Address(x,x+7);	
	
	Set_Row_Address(y,y+7);
	//Write_Register(0x5c);
			for(j=0;j<8;j++)
		{
			Data1=Hzk[2*no][2*j];
			Data2=Hzk[2*no][2*j+1];
				for(i=0;i<8;i++)
			{
				if(Data1&(0x01<<i))	
				{
					DATA1=0xF0;
				}
				else DATA1=0x00;
				if(Data2&(0x01<<i))
				{
					DATA1|=0x0F;
				}	
				Write_Parameter (DATA1);
				DATA1=0;
			}
		}
		
		
		
	Set_Colume_Address(x,x+7);	
	Set_Row_Address(y+8,y+15);
	//Write_Register(0x5c);
			for(j=0;j<8;j++)
		{
			Data1=Hzk[2*no+1][2*j];
			Data2=Hzk[2*no+1][2*j+1];
				for(i=0;i<8;i++)
			{
				if(Data1&(0x01<<i))	
				{
					DATA1=0xF0;
				}
				else DATA1=0x00;
				if(Data2&(0x01<<i))
				{
					DATA1|=0x0F;
				}	
				Write_Parameter (DATA1);
				DATA1=0;
			}
		}
}

void OLED_DrawBMP(u8 x1,u8 y1,u8 x2,u8 y2,u8 *BMP)
{
	unsigned char i,m=0;
	unsigned int k=0;
	
		Set_Colume_Address(x1,x2);
	// Row Address
	Set_Row_Address(y1,y2);

		for (m=0;m<y2-y1+1;m++) 
	{ 
		for (i=0;i<x2-x1+1;i++)   
		{//delay_ms(1);
			//Delay(10);
			 Write_Parameter(BMP[k++]);
			//Write_Parameter(BMP[k++]);
		}

}
}		

void OPEN_DC_POWER(void)
{
	Write_Register(0xAF);//OLEDƳģ
 Write_Register(0xb5);//ͨSSD1327 GPIOѹ·ʹܹܽ
 Write_Register(0x03);//0X03 GPIOΪߵƽʹ
}
void OFF_DC_POWER(void)
	{
		Write_Register(0xAE);//OLEDرսģʽ
	Write_Register(0xb5);//ͨSSD1327 GPIOѹ·ʹܹܽ
 Write_Register(0x02);//0X02 GPIOΪ͵ƽƽֹʹ
	}
void Initial_ssd1327(void)
{ 	
 
 	 
 	GPIO_InitTypeDef  GPIO_InitStructure;
 	
 	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);	 //ʹA˿ʱ
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_7;	 
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 		 //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;//ٶ50MHz
 	GPIO_Init(GPIOA, &GPIO_InitStructure);	  //ʼGPIOD3,6
 	GPIO_SetBits(GPIOA,GPIO_Pin_5|GPIO_Pin_7|GPIO_Pin_4);	
	
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);	 //ʹA˿ʱ
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1;	 
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 		 //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;//ٶ50MHz
 	GPIO_Init(GPIOB, &GPIO_InitStructure);	  //ʼGPIOD3,6
 	GPIO_SetBits(GPIOB,GPIO_Pin_0|GPIO_Pin_1);	
	 OLED_RST_Clr();	
	Delay(1000);	
	OLED_RST_Set();

Write_Register(0xae);//Set display off
Write_Register(0xa0);//Set re-map
Write_Register(0x55);
Write_Register(0xa1);//Set display start line
Write_Register(0x00);
Write_Register(0xa2);//Set display offset
Write_Register(0x00);
Write_Register(0xa4);//Normal Display
Write_Register(0xa8);//Set multiplex ratio
Write_Register(0x7f);
Write_Register(0xab);//Function Selection A
Write_Register(0x01);//Enable internal VDD regulator
Write_Register(0x81);//Set contrast
Write_Register(0x77);
Write_Register(0xb1);//Set Phase Length
Write_Register(0x31);
Write_Register(0xb3);//Set Front Clock Divider /Oscillator Frequency
Write_Register(0xb1);
Write_Register(0xb4); //For brightness enhancement
Write_Register(0xb5);
Write_Register(0x03);
Write_Register(0xb6);//Set Second pre-charge Period
Write_Register(0x0d);
Write_Register(0xbc);//Set Pre-charge voltage
Write_Register(0x07);
Write_Register(0xbe);//Set VCOMH
Write_Register(0x07);
Write_Register(0xd5);//Function Selection B
Write_Register(0x02);//Enable second pre-charge
Write_Register(0xaf);//Display on

}




























